function [mdl1, mdl2, bestPwrs1, bestPwrs2] = bestrathet6(XlFile,outFile)

warning('off');
format long

dt = datetime('now','TimeZone','local','Format','y-MMM-d HH_mm_ss');
dtstr = string(dt);
if nargin < 2, outFile = strcat("bestrathet6_",dtstr,".txt"); end
if nargin < 1, XlFile = strcat(pwd,'\bestrathet6.xlsx'); end
diary(outFile)

fprintf("Function bestrathet6\n\n");
fprintf("%s\n", dtstr);
fprintf("Please wait ....\n\n");

fprintf("Excel file used is %s\n", XlFile);
fprintf("Diary file used is %s\n", outFile);
% Open Excel as a COM Automation server
Excel = actxserver('Excel.Application');
% Open Excel workbook
Workbook = Excel.Workbooks.Open(XlFile);
% Clear the content of the sheet
Workbook.Worksheets.Item('List').Range('A2:Z100000').ClearContents;
Workbook.Worksheets.Item('List2').Range('A2:Z100000').ClearContents;  
Workbook.Worksheets.Item('Project').Range('A2:Z100000').ClearContents;  
Workbook.Worksheets.Item('Project2').Range('A2:Z100000').ClearContents;  
% Now save/close/quit
Workbook.Save;
Excel.Workbook.Close;
invoke(Excel, 'Quit');

hdrList = {'Adj R-square','YPwr','X1Pwr','X2Pwr','X3Pwr','YX1Pwr', ...
  'YX2Pwr','YXPwr3','Incercept','X1','X2','X2','X3','YX1','YX2','YX3'};
writecell(hdrList,XlFile,'Sheet','List');
writecell(hdrList,XlFile,'Sheet','List2');
hdrProject = {'Y','X1','X2','X3','YCalc','%Err'};
writecell(hdrProject,XlFile,'Sheet','Project');
writecell(hdrProject,XlFile,'Sheet','Project2');

xyData = readmatrix(XlFile,'Sheet','Data');
[maxrows,~] = size(xyData);
ydata = xyData(:,1);
x1data = xyData(:,2);
x2data = xyData(:,3);
x3data = xyData(:,4);
xyTransf = readmatrix(XlFile,'Sheet','Transf');
yPwrs = xyTransf(1:3,1);
x1Pwrs = xyTransf(1:3,2);
x2Pwrs = xyTransf(1:3,3);
x3Pwrs = xyTransf(1:3,4);
yx1Pwrs = xyTransf(1:3,5);
yx2Pwrs = xyTransf(1:3,6);
yx3Pwrs = xyTransf(1:3,7);
minAdjR2 = xyTransf(1,8);
yBuffer = zeros(maxrows,1);
x1Buffer = zeros(maxrows,1);
x2Buffer = zeros(maxrows,1);
x3Buffer = zeros(maxrows,1);
yx1Buffer = zeros(maxrows,1);
yx2Buffer = zeros(maxrows,1);
yx3Buffer = zeros(maxrows,1);

yCols = 0;
for yPwr =yPwrs(1):yPwrs(2):yPwrs(3)
  yCols = yCols + 1;
  yBuffer(:,yCols)= fx(ydata,yPwr);
end

x1Cols = 0;
for x1Pwr =x1Pwrs(1):x1Pwrs(2):x1Pwrs(3)
  x1Cols = x1Cols + 1;
  x1Buffer(:,x1Cols)= fx(x1data,x1Pwr);
end

x2Cols = 0;
for x2Pwr =x2Pwrs(1):x2Pwrs(2):x2Pwrs(3)
  x2Cols = x2Cols + 1;
  x2Buffer(:,x2Cols)= fx(x2data,x2Pwr);
end

x3Cols = 0;
for x3Pwr =x3Pwrs(1):x3Pwrs(2):x3Pwrs(3)
  x3Cols = x3Cols + 1;
  x3Buffer(:,x3Cols)= fx(x3data,x3Pwr);
end

yx1Cols = 0;
for yx1Pwr =yx1Pwrs(1):yx1Pwrs(2):yx1Pwrs(3)
  yx1Cols = yx1Cols + 1;
  yx1Buffer(:,yx1Cols)= fx(x1data,yx1Pwr);
end

yx2Cols = 0;
for yx2Pwr =yx2Pwrs(1):yx2Pwrs(2):yx2Pwrs(3)
  yx2Cols = yx2Cols + 1;
  yx2Buffer(:,yx2Cols)= fx(x2data,yx2Pwr);
end

yx3Cols = 0;
for yx3Pwr =yx3Pwrs(1):yx3Pwrs(2):yx3Pwrs(3)
  yx3Cols = yx3Cols + 1;
  yx3Buffer(:,yx3Cols)= fx(x3data,yx3Pwr);
end

bestAdjR2 = 0;
gRow = 0;
xyList = zeros(1,15);

yCols = 0;
for yPwr =yPwrs(1):yPwrs(2):yPwrs(3)
  yCols = yCols + 1;
  y = yBuffer(:,yCols);

  x1Cols = 0 ;
  for x1Pwr =x1Pwrs(1):x1Pwrs(2):x1Pwrs(3)
    x1Cols = x1Cols + 1;
    x1 = x1Buffer(:,x1Cols);

    x2Cols = 0  ;
    for x2Pwr =x2Pwrs(1):x2Pwrs(2):x2Pwrs(3)
      x2Cols = x2Cols + 1;
      x2 = x2Buffer(:,x2Cols);

      x3Cols = 0  ;
      for x3Pwr =x3Pwrs(1):x3Pwrs(2):x3Pwrs(3)
        x3Cols = x3Cols + 1;
        x3 = x3Buffer(:,x3Cols);

        yx1Cols = 0 ;
        for yx1Pwr =yx1Pwrs(1):yx1Pwrs(2):yx1Pwrs(3)
          yx1Cols = yx1Cols + 1;
          yx1 = yx1Buffer(:,yx1Cols);

          yx1 = -1 .* y .* yx1;

          yx2Cols = 0  ;
          for yx2Pwr =yx2Pwrs(1):yx2Pwrs(2):yx2Pwrs(3)
            yx2Cols = yx2Cols + 1;
            yx2 = yx2Buffer(:,yx2Cols);

            yx2 = -1 .* y .* yx2;

            yx3Cols = 0  ;
            for yx3Pwr =yx3Pwrs(1):yx3Pwrs(2):yx3Pwrs(3)
              yx3Cols = yx3Cols + 1;
              yx3 = yx3Buffer(:,yx3Cols);

              yx3 = -1 .* y .* yx3;

              X = [x1 x2 x3 yx1 yx2 yx3];

              mdl = fitlm(X,y);

              if mdl.Rsquared.Adjusted >= bestAdjR2
                bestAdjR2 = mdl.Rsquared.Adjusted;
                bestYpwr = yPwr;
                bestX1pwr = x1Pwr;
                bestX2pwr = x2Pwr;
                bestX3pwr = x3Pwr;
                bestYX1pwr = yx1Pwr;
                bestYX2pwr = yx2Pwr;
                bestYX3pwr = yx3Pwr;
                bestmdl = mdl;
              end

              if mdl.Rsquared.Adjusted >= minAdjR2
                gRow = gRow + 1;
                xyList(gRow,1) = mdl.Rsquared.Adjusted;
                xyList(gRow,2) = yPwr;
                xyList(gRow,3) = x1Pwr;
                xyList(gRow,4) = x2Pwr;
                xyList(gRow,5) = x3Pwr;
                xyList(gRow,6) = yx1Pwr;
                xyList(gRow,7) = yx2Pwr;
                xyList(gRow,8) = yx3Pwr;
                xyList(gRow,9)= mdl.Coefficients{1,1};
                xyList(gRow,10)= mdl.Coefficients{2,1};
                xyList(gRow,11)= mdl.Coefficients{3,1};
                xyList(gRow,12)= mdl.Coefficients{4,1};
                xyList(gRow,13)= mdl.Coefficients{5,1};
                xyList(gRow,14)= mdl.Coefficients{6,1};
                xyList(gRow,15)= mdl.Coefficients{7,1};
              end
            end
          end
        end
      end
    end
  end
end
[numRes,~] = size(xyList);
mdl = bestmdl;
bestPwrs1 = [bestYpwr bestX1pwr bestX2pwr bestX3pwr ...
  bestYX1pwr bestYX2pwr bestYX3pwr];
bestPwrs2 = [bestYpwr bestX1pwr bestX2pwr]; % default assignement
xyList = sortrows(xyList,1,"descend");
writematrix(xyList, XlFile, 'Sheet', 'List', 'Range',strcat('A2:O',num2str(numRes+1)));

% calculate projecttions
a = mdl.Coefficients{1,1};
b1 = mdl.Coefficients{2,1};
b2 = mdl.Coefficients{3,1};
b3 = mdl.Coefficients{4,1};
c1 = mdl.Coefficients{5,1};
c2 = mdl.Coefficients{6,1};
c3 = mdl.Coefficients{7,1};

ycalc = (a + b1.*fx(x1data,bestX1pwr) + ...
  b2.*fx(x2data,bestX2pwr) + ...
  b3.*fx(x3data,bestX3pwr))./ ...
  (1 + c1.*fx(x1data,bestYX1pwr) ...
  + c2.*fx(x2data,bestYX2pwr) ...
  + c3.*fx(x2data,bestYX3pwr));
if bestYpwr > 0
  ycalc = ycalc.^(1/bestYpwr);
elseif bestYpwr < 0
  ycalc = ycalc.^abs(bestYpwr);
else
  ycalc = exp(ycalc);
end
percErr = 100.*(ycalc-ydata)./ydata;
ProjMat = [ydata x1data x2data x3data ycalc percErr];
writematrix(ProjMat, XlFile, 'Sheet', 'Project', 'Range', strcat("A2:Z", num2str(1+length(ydata))));


% Print the summary of the best regression results
fprintf("Summary:\n");
fprintf("Adj R-sqr = %14.12f", bestAdjR2);
mdl
mdl1 = mdl;
mdl2 = mdl; % default assigment
fprintf("Best Y power = %f\n", bestYpwr);
fprintf("Best numerator X1 power = %f\n", bestX1pwr);
fprintf("Best numerator X2 power = %f\n", bestX2pwr);
fprintf("Best numerator X3 power = %f\n", bestX3pwr);
fprintf("Best denominator X1 power = %f\n", bestYX1pwr);
fprintf("Best denominator X2 power = %f\n", bestYX2pwr);
fprintf("Best denominator X3 power = %f\n", bestYX3pwr);

if bestYpwr ~= 1
  fprintf("=============================================\n");
  fprintf("\n\n------------------ Phase 2 -----------------\n\n");
  fprintf("=============================================\n");

  bestAdjR2 = 0;
  gRow = 0;
  xyList = zeros(1,15);

  y = ydata;

  x1Cols = 0 ;
  for x1Pwr =x1Pwrs(1):x1Pwrs(2):x1Pwrs(3)
    x1Cols = x1Cols + 1;
    x1 = x1Buffer(:,x1Cols);

    x2Cols = 0  ;
    for x2Pwr =x2Pwrs(1):x2Pwrs(2):x2Pwrs(3)
      x2Cols = x2Cols + 1;
      x2 = x2Buffer(:,x2Cols);

      x3Cols = 0  ;
      for x3Pwr =x3Pwrs(1):x3Pwrs(2):x3Pwrs(3)
        x3Cols = x3Cols + 1;
        x3 = x3Buffer(:,x3Cols);

        yx1Cols = 0 ;
        for yx1Pwr =yx1Pwrs(1):yx1Pwrs(2):yx1Pwrs(3)
          yx1Cols = yx1Cols + 1;
          yx1 = yx1Buffer(:,yx1Cols);

          yx1 = -1 .* y .* yx1;

          yx2Cols = 0  ;
          for yx2Pwr =yx2Pwrs(1):yx2Pwrs(2):yx2Pwrs(3)
            yx2Cols = yx2Cols + 1;
            yx2 = yx2Buffer(:,yx2Cols);

            yx2 = -1 .* y .* yx2;

            yx3Cols = 0  ;
            for yx3Pwr =yx3Pwrs(1):yx3Pwrs(2):yx3Pwrs(3)
              yx3Cols = yx3Cols + 1;
              yx3 = yx3Buffer(:,yx3Cols);

              yx3 = -1 .* y .* yx3;

              X = [x1 x2 x3 yx1 yx2 yx3];

              mdl = fitlm(X,y);

              if mdl.Rsquared.Adjusted >= bestAdjR2
                bestAdjR2 = mdl.Rsquared.Adjusted;
                bestYpwr = 1;
                bestX1pwr = x1Pwr;
                bestX2pwr = x2Pwr;
                bestX3pwr = x3Pwr;
                bestYX1pwr = yx1Pwr;
                bestYX2pwr = yx2Pwr;
                bestYX3pwr = yx3Pwr;
                bestmdl = mdl;
              end

              if mdl.Rsquared.Adjusted >= minAdjR2
                gRow = gRow + 1;
                xyList(gRow,1) = mdl.Rsquared.Adjusted;
                xyList(gRow,2) = 1;
                xyList(gRow,3) = x1Pwr;
                xyList(gRow,4) = x2Pwr;
                xyList(gRow,5) = x3Pwr;
                xyList(gRow,6) = yx1Pwr;
                xyList(gRow,7) = yx2Pwr;
                xyList(gRow,8) = yx3Pwr;
                xyList(gRow,9)= mdl.Coefficients{1,1};
                xyList(gRow,10)= mdl.Coefficients{2,1};
                xyList(gRow,11)= mdl.Coefficients{3,1};
                xyList(gRow,12)= mdl.Coefficients{4,1};
                xyList(gRow,13)= mdl.Coefficients{5,1};
                xyList(gRow,14)= mdl.Coefficients{6,1};
                xyList(gRow,15)= mdl.Coefficients{7,1};
              end
            end
          end
        end
      end
    end
  end

  [numRes,~] = size(xyList);
  mdl = bestmdl;
  xyList = sortrows(xyList,1,"descend");
  writematrix(xyList, XlFile, 'Sheet', 'List2', 'Range',strcat('A2:O',num2str(numRes+1)));

  % calculate projecttions
  a = mdl.Coefficients{1,1};
  b1 = mdl.Coefficients{2,1};
  b2 = mdl.Coefficients{3,1};
  b3 = mdl.Coefficients{4,1};
  c1 = mdl.Coefficients{5,1};
  c2 = mdl.Coefficients{6,1};
  c3 = mdl.Coefficients{7,1};

  ycalc = (a + b1.*fx(x1data,bestX1pwr) + ...
    b2.*fx(x2data,bestX2pwr) + ...
    b3.*fx(x3data,bestX3pwr))./ ...
    (1 + c1.*fx(x1data,bestYX1pwr) ...
    + c2.*fx(x2data,bestYX2pwr) ...
    + c3.*fx(x2data,bestYX3pwr));

  percErr = 100.*(ycalc-ydata)./ydata;
  ProjMat = [ydata x1data x2data x3data ycalc percErr];
  writematrix(ProjMat, XlFile, 'Sheet', 'Project2', 'Range', strcat("A2:Z", num2str(1+length(ydata))));

  % Print the summary of the best regression results
  fprintf("Summary:\n");
  fprintf("Adj R-sqr = %14.12f", bestAdjR2);
  mdl
  mdl2 = mdl;
  fprintf("Best Y power = %f\n", bestYpwr);
  fprintf("Best numerator X1 power = %f\n", bestX1pwr);
  fprintf("Best numerator X2 power = %f\n", bestX2pwr);
  fprintf("Best numerator X3 power = %f\n", bestX3pwr);
  fprintf("Best denominator X1 power = %f\n", bestYX1pwr);
  fprintf("Best denominator X2 power = %f\n", bestYX2pwr);
  fprintf("Best denominator X3 power = %f\n", bestYX3pwr);
end 

format short
diary off
end

function y = fx(x,pwr)
  if pwr > 0
    y = x.^pwr;
  elseif pwr < 0
    y = 1./x.^abs(pwr);
  else
    y = log(x);
  end
end