function [bestAdjR2,S] = fx631(ydata,xdata,x1Idx,xyTransf)
%FX631 Summary of this function goes here
%   Detailed explanation goes here
  S.model = strcat("(X1+X2+X3)/(X", num2str(x1Idx),")");
  maxrows = length(ydata);
  x1data = xdata(:,1);
  x2data = xdata(:,2);
  x3data = xdata(:,3);
  yx1data = xdata(:,x1Idx);
  yPwrs = xyTransf(1:3,1);
  x1Pwrs = xyTransf(1:3,2);
  x2Pwrs = xyTransf(1:3,3);
  x3Pwrs = xyTransf(1:3,4);
  yx1Pwrs = xyTransf(1:3,5);
  yBuffer = zeros(maxrows,1);
  yBuffer = zeros(maxrows,1);
  x1Buffer = zeros(maxrows,1);
  x2Buffer = zeros(maxrows,1);
  x3Buffer = zeros(maxrows,1);
  yx1Buffer = zeros(maxrows,1);
  
  yCols = 0;
  for yPwr =yPwrs(1):yPwrs(2):yPwrs(3)
    yCols = yCols + 1;
    yBuffer(:,yCols)= fx(ydata,yPwr);
  end
  
  x1Cols = 0;
  for x1Pwr =x1Pwrs(1):x1Pwrs(2):x1Pwrs(3)
    x1Cols = x1Cols + 1;
    x1Buffer(:,x1Cols)= fx(x1data,x1Pwr);
  end
  
  x2Cols = 0;
  for x2Pwr =x2Pwrs(1):x2Pwrs(2):x2Pwrs(3)
    x2Cols = x2Cols + 1;
    x2Buffer(:,x2Cols)= fx(x2data,x2Pwr);
  end
  
  x3Cols = 0;
  for x3Pwr =x3Pwrs(1):x3Pwrs(2):x3Pwrs(3)
    x3Cols = x3Cols + 1;
    x3Buffer(:,x3Cols)= fx(x3data,x3Pwr);
  end
  
  yx1Cols = 0;
  for yx1Pwr =yx1Pwrs(1):yx1Pwrs(2):yx1Pwrs(3)
    yx1Cols = yx1Cols + 1;
    yx1Buffer(:,yx1Cols)= fx(yx1data,yx1Pwr);
  end
  
  bestAdjR2 = 0;
  
  yCols = 0;
  for yPwr =yPwrs(1):yPwrs(2):yPwrs(3)
    yCols = yCols + 1;
    y = yBuffer(:,yCols);
  
    x1Cols = 0 ;
    for x1Pwr =x1Pwrs(1):x1Pwrs(2):x1Pwrs(3)
      x1Cols = x1Cols + 1;
      x1 = x1Buffer(:,x1Cols);
  
      x2Cols = 0  ;
      for x2Pwr =x2Pwrs(1):x2Pwrs(2):x2Pwrs(3)
        x2Cols = x2Cols + 1;
        x2 = x2Buffer(:,x2Cols);
  
        x3Cols = 0  ;
        for x3Pwr =x3Pwrs(1):x3Pwrs(2):x3Pwrs(3)
          x3Cols = x3Cols + 1;
          x3 = x3Buffer(:,x3Cols);
  
          yx1Cols = 0 ;
          for yx1Pwr =yx1Pwrs(1):yx1Pwrs(2):yx1Pwrs(3)
            yx1Cols = yx1Cols + 1;
            yx1 = yx1Buffer(:,yx1Cols);
  
            yx1 = -1 .* y .* yx1;
  
  
            X = [x1 x2 x3 yx1];
  
            mdl = fitlm(X,y);
  
            if mdl.Rsquared.Adjusted >= bestAdjR2
              bestAdjR2 = mdl.Rsquared.Adjusted;
              S.bestAdjR2 = bestAdjR2;
              S.bestYpwr = yPwr;
              S.bestX1pwr = x1Pwr;
              S.bestX2pwr = x2Pwr;
              S.bestX3pwr = x3Pwr;
              S.bestYX1pwr = yx1Pwr;
              S.bestx1Idx = x1Idx;
              S.bestmdl = mdl;
            end
          end
        end
      end
    end
  end
end

function y = fx(x,pwr)
  if pwr > 0
    y = x.^pwr;
  elseif pwr < 0
    y = 1./x.^abs(pwr);
  else
    y = log(x);
  end
end

