clc
clear all

warning('off');

dt = datetime('now','TimeZone','local','Format','y-MMM-d HH_mm_ss');
dtstr = string(dt);
filename = strcat(pwd,'\go44.xlsx');
outFile = strcat("go44_",dtstr,".txt");
diary(outFile)

fprintf("Program go44\n\n");
fprintf("%s\n", dtstr);
zBest = 0;

fprintf("Excel file used is %s\n", filename);
fprintf("Diary file used is %s\n", outFile);
xyData = readmatrix(filename,'Sheet','Data');
ydata =xyData(:,1);
xdata = xyData(:,2:end);

xyTransf = readmatrix(filename,'Sheet','T422');
[R422,S422] = fx422(ydata,xdata,xyTransf)
S422.bestmdl
if R422 > zBest
  zBest = R422;
  bestS = S422;
end

xyTransf = readmatrix(filename,'Sheet','T4211');
[R4211,S4211] = fx421(ydata,xdata,1,xyTransf)
S4211.bestmdl
if R4211 > zBest
  zBest = R4211;
  bestS = S4211;
end

xyTransf = readmatrix(filename,'Sheet','T4212');
[R4212,S4212] = fx421(ydata,xdata,2,xyTransf)
S4212.bestmdl
if R4212 > zBest
  zBest = R4212;
  bestS = S4212;
end

xyTransf = readmatrix(filename,'Sheet','T4121');
[R4121,S4121] = fx412(ydata,xdata,1,xyTransf)
S4121.bestmdl
if R4121 > zBest
  zBest = R4121;
  bestS = S4121;
end

xyTransf = readmatrix(filename,'Sheet','T4122');
[R4122,S4122] = fx412(ydata,xdata,2,xyTransf)
S4122.bestmdl
if R4122 > zBest
  zBest = R4122;
  bestS = S4122;
end

fprintf("\n===================\n\n")
fprintf("-------- Best Model --------\n\n");
bestS

diary off

