clc
clear all

warning('off');

dt = datetime('now','TimeZone','local','Format','y-MMM-d HH_mm_ss');
dtstr = string(dt);
filename = strcat(pwd,'\go66.xlsx');
outFile = strcat("go66_",dtstr,".txt");
diary(outFile)

zBest = 0;

fprintf("Program go66\n\n");
fprintf("%s\n", dtstr);
fprintf("Excel file used is %s\n", filename);
fprintf("Diary file used is %s\n", outFile);
xyData = readmatrix(filename,'Sheet','Data');
ydata =xyData(:,1);
xdata = xyData(:,2:end);

xyTransf = readmatrix(filename,'Sheet','T633');
[R633,S633] = fx633(ydata,xdata,xyTransf)
S633.bestmdl
if R633 > zBest
  zBest = R633;
  bestS = S633;
end

xyTransf = readmatrix(filename,'Sheet','T632');
[R6321,S6321] = fx632(ydata,xdata,1,2,xyTransf)
S6321.bestmdl
if R6321 > zBest
  zBest = R6321;
  bestS = S6321;
end

xyTransf = readmatrix(filename,'Sheet','T632');
[R6322,S6322] = fx632(ydata,xdata,1,3,xyTransf)
S6322.bestmdl
if R6322 > zBest
  zBest = R6322;
  bestS = S6322;
end

xyTransf = readmatrix(filename,'Sheet','T632');
[R6323,S6323] = fx632(ydata,xdata,2,3,xyTransf)
S6323.bestmdl
if R6323 > zBest
  zBest = R6323;
  bestS = S6323;
end


xyTransf = readmatrix(filename,'Sheet','T631');
[R6311,S6311] = fx631(ydata,xdata,1,xyTransf)
S6311.bestmdl
if R6311 > zBest
  zBest = R6311;
  bestS = S6311;
end

xyTransf = readmatrix(filename,'Sheet','T631');
[R6312,S6312] = fx631(ydata,xdata,2,xyTransf)
S6312.bestmdl
if R6312 > zBest
  zBest = R6312;
  bestS = S6312;
end

xyTransf = readmatrix(filename,'Sheet','T631');
[R6313,S6313] = fx631(ydata,xdata,3,xyTransf)
S6313.bestmdl
if R6313 > zBest
  zBest = R6313;
  bestS = S6313;
end

xyTransf = readmatrix(filename,'Sheet','T613');
[R6131,S6131] = fx613(ydata,xdata,1,xyTransf)
S6131.bestmdl
if R6131 > zBest
  zBest = R6131;
  bestS = S6131;
end

xyTransf = readmatrix(filename,'Sheet','T613');
[R6132,S6132] = fx613(ydata,xdata,2,xyTransf)
S6132.bestmdl
if R6132 > zBest
  zBest = R6132;
  bestS = S6132;
end

xyTransf = readmatrix(filename,'Sheet','T613');
[R6133,S6133] = fx613(ydata,xdata,3,xyTransf)
S6133.bestmdl
if R6133 > zBest
  zBest = R6133;
  bestS = S6133;
end

fprintf("\n===================\n\n")
fprintf("-------- Best Model --------\n\n");
zBest
bestS
bestS.bestmdl

diary off
