clc
clear all

warning('off');

dt = datetime('now','TimeZone','local','Format','y-MMM-d HH_mm_ss');
dtstr = string(dt);
filename = strcat(pwd,'\go66x.xlsx');
outFile = strcat("go66x_",dtstr,".txt");
diary(outFile)

fprintf("Program go66x\n\n");
fprintf("%s\n", dtstr);

zBest = 0;

fprintf("Excel file used is %s\n", filename);
fprintf("Diary file used is %s\n", outFile);
xyData = readmatrix(filename,'Sheet','Data');
ydata =xyData(:,1);
xdata = xyData(:,2:end);

xyTransf = readmatrix(filename,'Sheet','T633');
[R633,S633] = gx633(ydata,xdata,xyTransf)

S633.bestmdl
if R633 > zBest
  zBest = R633;
  bestS = S633;
end

xyTransf = readmatrix(filename,'Sheet','T623');
[R623, S623] = gx623(ydata,xdata,xyTransf)
S623.bestmdl
if R623 > zBest
  zBest = R623;
  bestS = S623;
end

xyTransf = readmatrix(filename,'Sheet','T623x');
[R623x1,S623x1] = gx623x(ydata,xdata,1,xyTransf)
S623x1.bestmdl
if R623x1 > zBest
  zBest = R623x1;
  bestS = S623x1;
end

xyTransf = readmatrix(filename,'Sheet','T623x');
[R6232x2,S623x2] = gx623x(ydata,xdata,2,xyTransf)
S623x2.bestmdl
if R6232x2 > zBest
  zBest = R6232x2;
  bestS = S623x2;
end

xyTransf = readmatrix(filename,'Sheet','T613');
[R6131,S6131] = gx613(ydata,xdata,1,xyTransf)
S6131.bestmdl
if R6131 > zBest
  zBest = R6131;
  bestS = S6131;
end

xyTransf = readmatrix(filename,'Sheet','T613');
[R6132,S6132] = gx613(ydata,xdata,2,xyTransf)
S6132.bestmdl
if R6132 > zBest
  zBest = R6132;
  bestS = S6132;
end


xyTransf = readmatrix(filename,'Sheet','T613x');
[R613x,S613x] = gx613x(ydata,xdata,xyTransf)
S613x.bestmdl
if R613x > zBest
  zBest = R613x;
  bestS = S613x;
end



fprintf("\n===================\n\n")
fprintf("-------- Best Model --------\n\n");
zBest
bestS
bestS.bestmdl

diary off
