function [bestAdjR2,S] = gx633(ydata,xdata,xyTransf)
%GX633 Summary of this function goes here
%   Detailed explanation goes here
  S.model = "(X1+X2+X1*X2)/(X1+X2+X1*X2)";
  maxrows = length(ydata);
  x1data = xdata(:,1);
  x2data = xdata(:,2);

  yPwrs = xyTransf(1:3,1);
  x1Pwrs = xyTransf(1:3,2);
  x2Pwrs = xyTransf(1:3,3);
  zx1Pwrs = xyTransf(1:3,4);
  zx2Pwrs = xyTransf(1:3,5);
  yx1Pwrs = xyTransf(1:3,6);
  yx2Pwrs = xyTransf(1:3,7);
  yzx1Pwrs = xyTransf(1:3,8);
  yzx2Pwrs = xyTransf(1:3,9);

  yBuffer = zeros(maxrows,1);
  x1Buffer = zeros(maxrows,1);
  x2Buffer = zeros(maxrows,1);
  zx1Buffer = zeros(maxrows,1);
  zx2Buffer = zeros(maxrows,1);
  yx1Buffer = zeros(maxrows,1);
  yx2Buffer = zeros(maxrows,1);
  yzx1Buffer = zeros(maxrows,1);
  yzx2Buffer = zeros(maxrows,1);
  
  yCols = 0;
  for yPwr =yPwrs(1):yPwrs(2):yPwrs(3)
    yCols = yCols + 1;
    yBuffer(:,yCols)= fx(ydata,yPwr);
  end
  
  x1Cols = 0;
  for x1Pwr =x1Pwrs(1):x1Pwrs(2):x1Pwrs(3)
    x1Cols = x1Cols + 1;
    x1Buffer(:,x1Cols)= fx(x1data,x1Pwr);
  end
  
  x2Cols = 0;
  for x2Pwr =x2Pwrs(1):x2Pwrs(2):x2Pwrs(3)
    x2Cols = x2Cols + 1;
    x2Buffer(:,x2Cols)= fx(x2data,x2Pwr);
  end
  
  zx1Cols = 0;
  for zx1Pwr =zx1Pwrs(1):zx1Pwrs(2):zx1Pwrs(3)
    zx1Cols = zx1Cols + 1;
    zx1Buffer(:,zx1Cols)= fx(x1data,zx1Pwr);
  end
  
  zx2Cols = 0;
  for zx2Pwr =zx2Pwrs(1):zx2Pwrs(2):zx2Pwrs(3)
    zx2Cols = zx2Cols + 1;
    zx2Buffer(:,zx2Cols) = fx(x2data,zx2Pwr);
  end
  
  yx1Cols = 0;
  for yx1Pwr =yx1Pwrs(1):yx1Pwrs(2):yx1Pwrs(3)
    yx1Cols = yx1Cols + 1;
    yx1Buffer(:,yx1Cols)= fx(x1data,yx1Pwr);
  end
  
  yx2Cols = 0;
  for yx2Pwr =yx2Pwrs(1):yx2Pwrs(2):yx2Pwrs(3)
    yx2Cols = yx2Cols + 1;
    yx2Buffer(:,yx2Cols)= fx(x2data,yx2Pwr);
  end
  
  yzx1Cols = 0;
  for yzx1Pwr =yzx1Pwrs(1):yzx1Pwrs(2):yzx1Pwrs(3)
    yzx1Cols = yzx1Cols + 1;
    yzx1Buffer(:,yzx1Cols)= fx(x1data,yzx1Pwr);
  end
  
  yzx2Cols = 0;
  for yzx2Pwr =yzx2Pwrs(1):yzx2Pwrs(2):yzx2Pwrs(3)
    yzx2Cols = yzx2Cols + 1;
    yzx2Buffer(:,yzx2Cols)= fx(x2data,yzx2Pwr);
  end
  
  
  bestAdjR2 = 0;
  
  yCols = 0;
  for yPwr =yPwrs(1):yPwrs(2):yPwrs(3)
    yCols = yCols + 1;
    y = yBuffer(:,yCols);
  
    x1Cols = 0;
    for x1Pwr =x1Pwrs(1):x1Pwrs(2):x1Pwrs(3)
      x1Cols = x1Cols + 1;
      x1 = x1Buffer(:,x1Cols);
  
      x2Cols = 0;
      for x2Pwr =x2Pwrs(1):x2Pwrs(2):x2Pwrs(3)
        x2Cols = x2Cols + 1;
        x2 = x2Buffer(:,x2Cols);
  
        zx1Cols = 0  ;
        for zx1Pwr =zx1Pwrs(1):zx1Pwrs(2):zx1Pwrs(3)
          zx1Cols = zx1Cols + 1;
          zx1 = zx1Buffer(:, zx1Cols);
  
          zx2Cols = 0;
          for zx2Pwr =zx2Pwrs(1):zx2Pwrs(2):zx2Pwrs(3)
            zx2Cols = zx2Cols + 1;
            zx2 = zx2Buffer(:, zx2Cols);
  
            zx = zx1 .* zx2;
  
            yx1Cols = 0;
            for yx1Pwr =yx1Pwrs(1):yx1Pwrs(2):yx1Pwrs(3)
              yx1Cols = yx1Cols + 1;
              yx1 = yx1Buffer(:,yx1Cols);
  
              yx1 = -1 .* y .* yx1;
  
              yx2Cols = 0;
              for yx2Pwr =yx2Pwrs(1):yx2Pwrs(2):yx2Pwrs(3)
                yx2Cols = yx2Cols + 1;
                yx2 = yx2Buffer(:,yx2Cols);
  
                yx2 = -1 .* y .* yx2;
  
                yzx1Cols = 0;
                for yzx1Pwr =yzx1Pwrs(1):yzx1Pwrs(2):yzx1Pwrs(3)
                  yzx1Cols = yzx1Cols + 1;
                  yzx1 = yzx1Buffer(:, yzx1Cols);
  
                  yzx2Cols = 0;
                  for yzx2Pwr =yzx2Pwrs(1):yzx2Pwrs(2):yzx2Pwrs(3)
                    yzx2Cols = yzx2Cols + 1;
                    yzx2 = yzx2Buffer(:, yzx2Cols);
  
                    yzx = -1 .* y .* yzx1 .* yzx2;
  
                    X = [x1 x2 zx yx1 yx2 yzx];
  
                    mdl = fitlm(X,y);
  
                    if mdl.Rsquared.Adjusted >= bestAdjR2
                      bestAdjR2 = mdl.Rsquared.Adjusted;
                      S.bestAdjR2 = bestAdjR2;
                      S.bestYpwr = yPwr;
                      S.bestX1pwr = x1Pwr;
                      S.bestX2pwr = x2Pwr;
                      S.bestZX1pwr = zx1Pwr;
                      S.bestZX2pwr = zx2Pwr;
                      S.bestYX1pwr = yx1Pwr;
                      S.bestYX2pwr = yx2Pwr;
                      S.bestZYX1pwr = yzx1Pwr;
                      S.bestZYX2pwr = yzx2Pwr;
                      S.bestmdl = mdl;
                    end
                  end
                end
              end
            end
          end
        end
      end
    end
  end
end

function y = fx(x,pwr)
  if pwr > 0
    y = x.^pwr;
  elseif pwr < 0
    y = 1./x.^abs(pwr);
  else
    y = log(x);
  end
end

